#
# This is the SPEC file for creating binary RPMs for the Dom0.
#
#
# The Qubes OS Project, http://www.qubes-os.org
#
# Copyright (C) 2010  Joanna Rutkowska <joanna@invisiblethingslab.com>
# Copyright (C) 2010  Rafal Wojtczuk  <rafal@invisiblethingslab.com>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, see <https://www.gnu.org/licenses/>.
#
#

Name:		qubes-core-qrexec
Version:	4.2.8
Release:	1%{dist}
Summary:	The Qubes qrexec files (common files)

Group:		Qubes
Vendor:		Invisible Things Lab
License:	GPL
URL:		http://www.qubes-os.org

BuildRequires:	gcc
BuildRequires:  python%{python3_pkgversion}-devel
BuildRequires:	python%{python3_pkgversion}-dbus
# for building documentation
BuildRequires:	python%{python3_pkgversion}-sphinx
BuildRequires:	python%{python3_pkgversion}-recommonmark
BuildRequires:	qubes-libvchan-devel
BuildRequires:  python%{python3_pkgversion}-rpm-macros

Requires:   python%{python3_pkgversion}
Requires:   python%{python3_pkgversion}-gbulb
Conflicts:  qubes-utils-libs < 4.1.0
Conflicts:  qubes-core-agent-qrexec < 4.1.0
Conflicts:  qubes-core-dom0 < 4.1.10
Conflicts:  qubes-core-dom0-linux < 4.1.5
Conflicts:  qubes-gui-agent < 4.1.6
Conflicts:  qubes-gpg-split < 2.0.45
Conflicts:  qubes-gui-daemon < 4.1.4
Conflicts:  qubes-input-proxy < 1.0.17
Conflicts:  qubes-pdf-converter < 2.1.7
Conflicts:  qubes-usb-proxy < 1.0.28

Source0: qubes-core-qrexec-%{version}.tar.gz

%description
The Qubes qrexec files for installation on both dom0 and qube.

%package libs
Summary:    Libraries for qubes-qrexec
Conflicts:  qubes-utils-libs < 4.1.0

%description libs
Libraries for qubes-qrexec

%package devel
Summary:    Development headers for qubes-qrexec
Requires:   %{name}-libs

%description devel
Development header and files for qubes-qrexec

%prep
%setup -qn qubes-core-qrexec-%{version}

%build
%{?set_build_flags}
make all-base PYTHON=%{__python3}
make -C doc PYTHON=python3 SPHINXBUILD=sphinx-build-3 man

%install
make install-base \
    INCLUDEDIR=%{_includedir} \
    LIBDIR=%{_libdir} \
    SYSCONFDIR=%{_sysconfdir} \
    UNITDIR=%{_unitdir} \
    PYTHON_SITEPATH=%{python3_sitelib} \
    PYTHON=%{__python3} \
    DESTDIR=$RPM_BUILD_ROOT

make -C doc \
    DESTDIR=$RPM_BUILD_ROOT \
    SPHINXBUILD=sphinx-build-3 \
    install

%clean
rm -rf $RPM_BUILD_ROOT
rm -f %{name}-%{version}

%files
%defattr(-,root,root,-)

%{_bindir}/qrexec-policy-exec
%{_bindir}/qrexec-policy-agent
%{_bindir}/qrexec-policy-graph
%{_bindir}/qrexec-policy-restore
%{_bindir}/qrexec-policy-daemon
%{_bindir}/qubes-policy
%{_bindir}/qubes-policy-admin
%{_bindir}/qrexec-policy

/usr/lib/qubes/qubes-rpc-multiplexer
/usr/lib/qubes/qrexec-policy-agent-autostart

%{_sysconfdir}/qubes-rpc/policy.Ask
%{_sysconfdir}/qubes-rpc/policy.Notify

%{_sysconfdir}/xdg/autostart/qrexec-policy-agent.desktop

%dir %{python3_sitelib}/qrexec-*.egg-info
%{python3_sitelib}/qrexec-*.egg-info/*

%dir %{python3_sitelib}/qrexec
%dir %{python3_sitelib}/qrexec/__pycache__
%{python3_sitelib}/qrexec/__pycache__/*
%{python3_sitelib}/qrexec/__init__.py
%{python3_sitelib}/qrexec/client.py
%{python3_sitelib}/qrexec/exc.py
%{python3_sitelib}/qrexec/utils.py
%{python3_sitelib}/qrexec/server.py

%dir %{python3_sitelib}/qrexec/policy
%dir %{python3_sitelib}/qrexec/policy/__pycache__
%{python3_sitelib}/qrexec/policy/__pycache__/*
%{python3_sitelib}/qrexec/policy/__init__.py
%{python3_sitelib}/qrexec/policy/admin.py
%{python3_sitelib}/qrexec/policy/admin_client.py
%{python3_sitelib}/qrexec/policy/parser.py
%{python3_sitelib}/qrexec/policy/parser_compat.py
%{python3_sitelib}/qrexec/policy/utils.py

%dir %{python3_sitelib}/qrexec/tools
%dir %{python3_sitelib}/qrexec/tools/__pycache__
%{python3_sitelib}/qrexec/tools/__pycache__/*
%{python3_sitelib}/qrexec/tools/__init__.py
%{python3_sitelib}/qrexec/tools/qubes_policy.py
%{python3_sitelib}/qrexec/tools/qubes_policy_admin.py
%{python3_sitelib}/qrexec/tools/qrexec_policy_agent.py
%{python3_sitelib}/qrexec/tools/qrexec_policy_exec.py
%{python3_sitelib}/qrexec/tools/qrexec_policy_daemon.py
%{python3_sitelib}/qrexec/tools/qrexec_policy_graph.py
%{python3_sitelib}/qrexec/tools/qrexec_policy_restore.py

%dir %{python3_sitelib}/qrexec/tests
%dir %{python3_sitelib}/qrexec/tests/__pycache__
%{python3_sitelib}/qrexec/tests/__pycache__/*
%{python3_sitelib}/qrexec/tests/__init__.py
%{python3_sitelib}/qrexec/tests/cli.py
%{python3_sitelib}/qrexec/tests/gtkhelpers.py
%{python3_sitelib}/qrexec/tests/rpcconfirmation.py
%{python3_sitelib}/qrexec/tests/policy_parser.py
%{python3_sitelib}/qrexec/tests/qrexec_policy_daemon.py
%{python3_sitelib}/qrexec/tests/policy_cache.py
%{python3_sitelib}/qrexec/tests/server.py
%{python3_sitelib}/qrexec/tests/policy_admin.py

%dir %{python3_sitelib}/qrexec/tests/socket
%dir %{python3_sitelib}/qrexec/tests/socket/__pycache__
%{python3_sitelib}/qrexec/tests/socket/__pycache__/*
%{python3_sitelib}/qrexec/tests/socket/__init__.py
%{python3_sitelib}/qrexec/tests/socket/agent.py
%{python3_sitelib}/qrexec/tests/socket/daemon.py
%{python3_sitelib}/qrexec/tests/socket/qrexec.py
%{python3_sitelib}/qrexec/tests/socket/util.py

%dir %{python3_sitelib}/qrexec/glade
%{python3_sitelib}/qrexec/glade/RPCConfirmationWindow.glade

%{_datadir}/man/man1/qubes-core-qrexec.1.gz

%files devel
%{_includedir}/qrexec.h
%{_includedir}/libqrexec-utils.h

%files libs
%{_libdir}/libqrexec-utils.so*

%changelog
* Fri Jul 21 2023 Qubes OS Team <qubes-devel@googlegroups.com>
- For complete changelog see: https://github.com/QubesOS/qubes-core-qrexec

* Fri Jul 21 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 403eaa2
- version 4.2.8

* Sat Jul 08 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 349e42c
- Make policy.RegisterArgument use new policy format

* Sun Jul 02 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 10adc83
- version 4.2.7

* Fri Jun 30 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - fdcbfd7
- Reject service names that start with +

* Fri Jun 30 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 6cb897a
- Reject interior NUL bytes in service name

* Fri May 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 4ca6be1
- Move variables into MSG_TRIGGER_SERVICE3 block

* Fri May 26 2023 Ben Grande <ben.grande.b@gmail.com> - 587fa68
- Fix python3-qrexec missing on qubes-core-qrexec

* Fri May 26 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 87ea44e
- daemon: fix memory leak

* Fri May 26 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - d667dec
- daemon: add missing brackets in validate_request_id

* Wed May 24 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 5eefd4e
- Ensure that all external variables are type-checked

* Wed May 24 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 6e18e38
- Banish old-style function declarations

* Tue May 23 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - c70709d
- Shut up pylint

* Tue May 23 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 07075e9
- Support Debian 11

* Fri May 19 2023 Ben Grande <ben.grande.b@gmail.com> - d0f4a16
- Fix missing include in RPC names in admin_client

* Thu May 18 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - fd1f249
- Fix header validation by qrexec agent

* Thu May 18 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - a0121aa
- Revert "Use close_range(2) instead of manual close loop"

* Mon May 15 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 9e70ff8
- fuzz: daemon->handle_message_from_agent()

* Mon May 15 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 84f9d18
- fuzz: fix generating seed corpus

* Mon May 15 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 249a64c
- fuzz: add mockup of libvchan_client_init()

* Mon May 15 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - f9c8147
- daemon: prepare handle_message_from_agent() for fuzzing

* Mon May 15 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 0b8891e
- daemon: add missing return to the main() function

* Thu May 11 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 92071a5
- Restore VMToken properties/methods

* Thu May 11 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - b1007c3
- version 4.2.6

* Thu May 11 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 322bcf6
- daemon: fix off-by-one in MSG_TRIGGER_SERVICE3 validation

* Sun May 07 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 32501cd
- Do not use 'annotation' future extension

* Sat May 06 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 842375b
- Reject requests with invalid request ID

* Wed May 03 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 69a21b7
- version 4.2.5

* Sat Apr 29 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 0ab2ac1
- Avoid having qrexec-policy-daemon handle connections

* Sat Apr 29 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 721767c
- Use pytest_asyncio.fixture() for async test fixtures

* Thu Apr 27 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 6e6226a
- Add types to Python code

* Thu Apr 27 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 8df2627
- qrexec-client: Allow killing the VM before exiting

* Thu Apr 27 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 36da281
- Add new utility functions to libqrexec

* Wed Apr 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 6a00e92
- avoid option injection in 'make clean'

* Wed Apr 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 93a0b39
- Clean up gcov cruft in 'make clean'

* Wed Apr 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - c97ad3a
- Fix make install when already installed

* Wed Apr 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - f84f578
- Fix some mypy errors

* Wed Apr 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 975a980
- Forcibly rebuild C code for socket tests

* Wed Apr 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 82483ef
- Avoid option injection for usernames starting with "-"

* Wed Apr 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 721c34f
- Add missing static

* Wed Apr 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 59e65f0
- Add a missing #include

* Wed Apr 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - ace6261
- More consistency checks in buffer code

* Wed Apr 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - b7851c8
- Correctly detect SOCK_CLOEXEC

* Wed Apr 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - af828db
- Slightly better validation of data from dom0

* Wed Apr 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - b404a66
- Fix reserved identifier violations

* Wed Apr 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - cd784de
- Avoid K&R function declarations

* Wed Apr 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 5b678d9
- Ensure all data is sent to policy daemon

* Wed Apr 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 7de0f06
- Ignore stopped or continued children

* Wed Apr 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - a1cfe66
- Fix signal handling bugs

* Wed Apr 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 1e3d0c9
- Check return value of snprintf()

* Wed Apr 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - e796a2a
- Use close_range(2) instead of manual close loop

